/**********************************************************************
 *
 * nullproto.h -- 
 * Copyright (C) 1999  The New Zealand Digital Library Project
 *
 * PUT COPYRIGHT NOTICE HERE
 *
 * $Id: nullproto.h 166 1999-02-21 22:35:26Z rjmcnab $
 *
 *********************************************************************/


#ifndef NULLPROTO_H
#define NULLPROTO_H

#include "gsdlconf.h"
#include "collectserver.h"
#include "recptproto.h"


class nullproto : public recptproto {
protected:
  collectservermapclass cservers;
public:
  virtual ~nullproto() {}

  // add_collectserver should be called for each collection server
  // before any configuration is done
  void add_collectserver (collectserver *thecserver) 
    {cservers.addcollectserver(thecserver);}

  // this configure will configure each of the collection servers
  void configure (const text_t &key, const text_tarray &cfgline);

  // this init will init each of the collection servers
  bool init (ostream &logout);

  text_t get_protocol_name ();
  void get_collection_list (text_tarray &collist, comerror_t &err, 
			    ostream &logout);
  void has_collection (const text_t &collection, bool &hascollection, 
		       comerror_t &err, ostream &logout);
  void ping (const text_t &collection, bool &wassuccess, 
	     comerror_t &err, ostream &logout);
  void get_collectinfo (const text_t &collection, 
			ColInfoResponse_t &collectinfo,
			comerror_t &err, ostream &logout);
};


#endif
